/******************************************************************************
* @brief provide high-level startup routines for NV32F100.
*
*******************************************************************************/

#include "system_nv32f100.h"
#include "common.h"
#include "wdog.h"
#include "sim.h"
#include "uart.h"
#include "ics.h"

void start(void);
void SystemInit( void );
static void SetSysClock(void);
void UART_InitPrint(void);
/********************************************************************/
/*!
 * \ϵͳʼ
 */
void SystemInit( void )
{   
#if !defined(ENABLE_WDOG)   
    /* ÿŹ */
    WDOG_Disable();
#else
    /* ÿŹ */
    WDOG_DisableWDOGEnableUpdate();    
#endif
    /* FLASHȴ */
    EFMCR &= 0xFFFF0001;
         
#if defined(TRIM_IRC)    
    /* ǷʹóڲУ׼ֵʹע͵TRIM_IRC */
    ICS_Trim(ICS_TRIM_VALUE);
#endif  
    /* ϵһдλSWD,RST,NMI */
    //SIM->SOPT = 0x0000000E;//ʹSWDRSTNMI
    SIM->SOPT = 0x0000000C;//ʹSWDRSTNMI
    //SIM->SOPT = 0x00000004;//ʹRSTSWDԼNMI
      
    SetSysClock();
	
	  UART_InitPrint();
      
}

/*!
 * \ϵͳʱ
 */
static void SetSysClock(void)
{
    ICS_ConfigType  sICSConfig = {0};
             
#if defined(CRYST_HIGH_GAIN)    
    sICSConfig.oscConfig.bGain = 1;           /* ʹܸģʽ */      
#endif

#if  (EXT_CLK_FREQ_KHZ >=4000)
    sICSConfig.oscConfig.bRange = 1;          /* OSCΪ߷Χ */
#endif
	
    sICSConfig.oscConfig.bEnable = 1;         /* ʹOSC */
    sICSConfig.u32ClkFreq = EXT_CLK_FREQ_KHZ;
    
#if     defined(USE_FEE)    
    sICSConfig.u8ClkMode = ICS_CLK_MODE_FEE;    
#elif	defined(USE_FBE_OSC)
    sICSConfig.u8ClkMode = ICS_CLK_MODE_FBE_OSC;    
#elif	defined(USE_FEE_OSC)   
    sICSConfig.u8ClkMode = ICS_CLK_MODE_FEE_OSC;    
#elif	defined(USE_FBILP)   
    sICSConfig.u8ClkMode = ICS_CLK_MODE_FBILP;
#elif	defined(USE_FBELP)   
    sICSConfig.u8ClkMode = ICS_CLK_MODE_FBELP; 		
#endif      

    ICS_Init(&sICSConfig);   /* initialize ICS */
}


void UART_InitPrint(void)
{
    UART_ConfigType sConfig;

    sConfig.u32SysClkHz = BUS_CLK_HZ;
    sConfig.u32Baudrate  = UART_PRINT_BITRATE;
    
    UART_Init (TERM_PORT, &sConfig);
}

