/***********************************************************************!     
 *     ۣQQȺ  123763203
 *         www.navota.com
 *
 * @file       flash.c
 * @brief      flash
 * @author     Navota
 * @date       2018-3-1
 ************************************************************************/

/****************ע********************/
// йFlash/̵زӦRAMִ
// FlashĲԪСΪ-512ֽ
// FlashıСλΪ-4ֽ
 
#include "flash.h"

/*****************************************************************************//*!
*
* @brief ʼFLASH
*        
* @param  
*
* @return none
*
*****************************************************************************/

uint16_t Flash_Init(void)
{
	uint16_t err   = FLASH_ERR_SUCCESS;
	uint32_t clkDIV = BUS_CLK_HZ/1000000L - 1;
	uint32_t Tpgs  =(285 *(BUS_CLK_HZ/100))/1000000L; 
	uint32_t Tprog =(675*(BUS_CLK_HZ/100))/1000000L;  
//        printf("Tpgs= %x \n" , Tpgs);
//        printf("Tprog= %x \n" , Tprog);   
        
	EFMCR=(clkDIV<<24) + 0x00000001; //divide to 1M hz   //Modify
	EFMETM0=(Tpgs<<16)  + 0x00001194;  //0x00281194; //
	EFMETM1=(Tprog<<16) + 0x000088B8; //

  return(err);
}


/*****************************************************************************//*!
*
* @brief    flashر:ֽڳȣдֵĸ
*           дʣһֵĸдʣֽ
*        
* @param[in]     wNVMTargetAddress     ҪŵFLASH׵ַ
* @param[in]     *pData                Ҫŵ
* @param[in]     sizeBytes             ֽڳ
*
* @return none
*
*****************************************************************************/

uint16_t Flash_Program(uint32_t wNVMTargetAddress, uint8_t *pData, uint16_t sizeBytes)
{
	uint16_t err = FLASH_ERR_SUCCESS;
	uint16_t w2LongWordCount = sizeBytes>>3;//һ£õ2ֵĸ
	uint8_t  wLeftBytes = (sizeBytes & 0x07);//λֽڵĸ
	uint16_t wLeftLongWords = wLeftBytes>>2;//λһָ
	uint32_t wTargetAddress = wNVMTargetAddress;
	uint32_t dwData0,dwData1;
	uint32_t *pdwData = (uint32_t*)pData;//
	int  i;
        //жǷֶ
	if(wNVMTargetAddress & 0x03)
	{
		err = FLASH_ERR_INVALID_PARAM;
		return (err);//ЧĲ
	}
	//ѭд֣8ֽڣдw2LongWordCount * 8ֽ
	for(i = 0; i < w2LongWordCount; i++)
	{
		dwData0 = *pdwData++;
		dwData1 = *pdwData++;
		err = Flash_Program2LongWords(wTargetAddress, dwData0, dwData1);//ֵı
		if(err) //ַΪ4ֽڶ룬ֱת
		{
			goto EndP;
			//break;
		}
		wTargetAddress += 8;//ѭһд8ֽڣ2֣NV32flashֶ
	}
	// һֵı̣4bytes
	for(i = 0; i < wLeftLongWords; i++)
	{
		dwData0 = *pdwData++;
		//printf("\n adr : 0x%x ,data = 0x%x\n",i,dwData0 );
		err = Flash_Program1LongWord(wTargetAddress, dwData0);
    //printf("\n adr : 0x%x ,data = 0x%x\n",i,dwData0 );
		if(err)
		{			
			goto EndP;
			//break;
		}
		wTargetAddress += 4;
	}
	wLeftBytes = (wLeftBytes-(wLeftLongWords<<2));	//ֺһֵı̶ʣĵλֽ
	if(!wLeftBytes){ //ʣֽسɹ
		return (err);
	}
        
#if  defined(BIG_ENDIAN)                
	dwData0 = 0;
	pData = (uint8_t*)pdwData;	
	for(i = wLeftBytes; i >0; i--)
	{
		dwData0 <<= 8;
		dwData0 |= *pData++;	
	}
	
	wLeftBytes = 4 - wLeftBytes;	 
	for(i = wLeftBytes; i >0; i--)
	{
		dwData0 <<= 8;
		dwData0 |= 0xFF;	
	}
#else
	dwData0 = 0xFFFFFFFFL;        
	pData = (uint8_t*)pdwData+wLeftBytes-1;	
	for(i = wLeftBytes; i >0; i--)
	{
		dwData0 <<= 8;
		dwData0 |= *pData--;	
	}
#endif	
	err = Flash_Program1LongWord(wTargetAddress, dwData0);	
EndP:	
	return (err);
}


/*****************************************************************************//*!
*
* @brief  һֵĴС̵FLASH(Ҳĸֽ)
*        
* @param[in]     wNVMTargetAddress     ҪŵFLASH׵ַ
* @param[in]     dwData                Ҫŵ
*
* @return none  
*
*****************************************************************************/
uint16_t Flash_Program1LongWord(uint32_t wNVMTargetAddress, uint32_t dwData)
{
	uint16_t err = FLASH_ERR_SUCCESS;
	
	//жǷΪֶ
	if(wNVMTargetAddress & 0x03)
	{
		err = FLASH_ERR_INVALID_PARAM;
		return (err);
	}
	DisableInterrupts;
  //־
	EFMCMD = FLASH_CMD_CLEAR;
	//дݵӦĵַ
	M32(wNVMTargetAddress) = dwData;
	//ر	
  EFM_LaunchCMD(FLASH_CMD_PROGRAM);
	EnableInterrupts;
	return (err);//״̬
}


/*****************************************************************************//*!
*
* @brief  ֵĴС̵FLASH(Ҳǰ˸ֽ)
*        
* @param[in]     wNVMTargetAddress     ҪŵFLASH׵ַ
* @param[in]     dwData0               4ֽ
* @param[in]     dwData1               4ֽ
*
* @return none  
*
*****************************************************************************/
uint16_t Flash_Program2LongWords(uint32_t wNVMTargetAddress, uint32_t dwData0, uint32_t dwData1)
{
	uint16_t err = FLASH_ERR_SUCCESS;

	
	//жǷΪֶ
	if(wNVMTargetAddress & 0x03)
	{
		err = FLASH_ERR_INVALID_PARAM;
		return (err);
	}
	DisableInterrupts;
	// ־
	EFMCMD = FLASH_CMD_CLEAR;
//	printf("\n write data  adr : 0x%x ,data = 0x%x\n",dwData0,dwData1 );
	M32(wNVMTargetAddress) = dwData0;//ݵĿַΪʼ4ֽڵĿռ
  EFM_LaunchCMD(FLASH_CMD_PROGRAM);//0x20000000,ر
	EnableInterrupts;
	
	wNVMTargetAddress = wNVMTargetAddress +4;//ֶַģַһ
	
  DisableInterrupts;
	EFMCMD = FLASH_CMD_CLEAR;
	M32(wNVMTargetAddress) = dwData1;//ڶݷ봦ĵַ4ֽڵĿռ
  EFM_LaunchCMD(FLASH_CMD_PROGRAM);//ر
	EnableInterrupts;
	return (err);//ش״̬
}


/*****************************************************************************//*!
*
* @brief Ŀַһ512ֽڣ
*        
* @param[in]    wNVMTargetAddress   ׵ַ
*
* @return none
*
*****************************************************************************/
uint16_t  Flash_EraseSector(uint32_t wNVMTargetAddress)
{
	uint16_t err = FLASH_ERR_SUCCESS;
	// жǷֶ
	if(wNVMTargetAddress & 0x03)
	{
		err = FLASH_ERR_INVALID_PARAM;
		return (err);
	}
	  DisableInterrupts;
	  //־
		EFMCMD = FLASH_CMD_CLEAR;
	  M32(wNVMTargetAddress) = 0xffffffff;
	  EFM_LaunchCMD(FLASH_CMD_ERASE_SECTOR);//ز
	  EnableInterrupts;
	
	return (err);
}


/*****************************************************************************//*!
*
* @brief ƬFLASH(ãע0X40EַڵԽ׶д0XFE)
*        
* @param  
*	
* @return none
*
*****************************************************************************/
uint16_t NVM_EraseAll(void)
{
		uint16_t err = FLASH_ERR_SUCCESS;
	
	  DisableInterrupts;
		EFMCMD = FLASH_CMD_CLEAR;
	  EFM_LaunchCMD(FLASH_CMD_ERASE_ALL);
	  EnableInterrupts;
	
    return err;
}


/*****************************************************************************//*!
*
* @brief غ(ע˺SRAM)
*        
* @param  
*	
* @return none
*
*****************************************************************************/
void EFM_LaunchCMD(uint32_t EFM_CMD)
{
	DisableInterrupts;
	
		if((EFMCMD&EFM_DONE_MASK)== EFM_STATUS_READY)
		{
	  EFMCMD = EFM_CMD;
		}
	while(1)
	{
		if((EFMCMD&EFM_DONE_MASK) == EFM_STATUS_DONE) break;
	}
	
	EnableInterrupts;
}
